local onEvent = {}
--- edited by icreator
local _PS = {}
get_PS = function( key )
	return key == nil and _PS or _PS[key]
end
set_PS = function( key, val )
	_PS[key] = val
end

reset_PS = function()
	_PS = {} ---   
	---    config.txt
	for k, v in PS do
		_PS[k] = v
	end
end

local widgets = {}
local widget = mainForm:GetChildChecked("NamePlateBar", false)
widget:Show(false)
local wtDevice = mainForm:GetChildChecked("NameDevice", false)
wtDevice:Show(false)
local emotePlace = widget:GetChildChecked("Emote1", false):GetPlacementPlain()

local widgetdesc = widget:GetWidgetDesc()
local wtDevDesc = wtDevice:GetWidgetDesc()
local wtControl3D = stateMainForm:GetChildChecked( "MainAddonMainForm", false ):GetChildChecked( "MainScreenControl3D", false )
local units = {}
local DetIcons = {}
local NPB = {}
local Color = {
	["BG"] = {r=0;g=0;b=0;a=0.3},
	["En"] = {r=.8;g=0.2;b=0.1;a=1},
	["Fr"] = {r=0.2;g=.6;b=0.2;a=1},
	["EP"] = {r=1;g=0;b=0;a=1},
	["Ne"] = {r=.7;g=.7;b=0.0;a=1},
	["In"] = {r=0;g=0;b=0;a=0},
	["EnB"] = {r=.3;g=0.1;b=0.1;a=1},
	["FrB"] = {r=0;g=.2;b=0;a=1},
	["EPB"] = {r=0.4;g=0;b=0;a=1},
	["NeB"] = {r=.3;g=.3;b=0;a=1},

	["GP"] = {r=.3;g=.3;b=0.7;a=1},
	["GPB"] = {r=.0;g=.0;b=0.4;a=1},
	["RD"] = {r=.75;g=.42;b=.2;a=1},
	["RDB"] = {r=.3;g=.2;b=0.3;a=1},
}
local Name, TargName, TargID = {}, {}, {}
local Level = {}
local Title = {}

local CC = {
	["WARRIOR"] = "LogColorBrown",
	["PALADIN"] = "LogColorWhite",
	["MAGE"] = "LogColorLightBlue",
	["DRUID"] = "LogColorOrange",
	["PSIONIC"] = "LogColorMagenta",
	["STALKER"] = "LogColorGreen",
	["PRIEST"] = "LogColorYellow",
	["NECROMANCER"] = "LogColorLightRed",
	["BARD"] = "LogColorLightGreen",
}
local ClassNames = {
	[ "WARRIOR" ] = "WA",
	[ "NECROMANCER" ] = "NE",
	[ "MAGE" ] = "MA",
	[ "DRUID" ] = "DR",
	[ "PSIONIC" ] = "PS",
	[ "PALADIN" ] = "PA",
	[ "PRIEST" ] = "PR",
	[ "STALKER" ] = "ST",
	[ "BARD" ] = "BA",
	}

local Me, MyLVL, MyGuild, MySpouse
local pets = {} --   

local function HPbarSize(healthbar, v) --- icreator
	local P = healthbar:GetChildChecked("Bar", false):GetPlacementPlain()
	local hp = unit.GetHealthPercentage(v)/100
	local HPbarP = healthbar:GetParent():GetPlacementPlain() --- icreator
	local HPsizeX = HPbarP.sizeX --- icreator

	P.highPosX = (1 - unit.GetHealthPercentage(v)/100) * HPsizeX --- icreator
	healthbar:GetChildChecked("Bar", false):SetPlacementPlain(P)
	--hp = hp>0.9 and 0.5 or 1 healthbar:SetFade( hp )
	--[[ --     SetFade
	local clr
	clr = healthbar:GetChildChecked("Bar", false):GetBackgroundColor()
	clr.a = hp
	healthbar:GetChildChecked("Bar", false):SetBackgroundColor(clr)
	clr = healthbar:GetBackgroundColor()
	clr.a = hp
	healthbar:SetBackgroundColor(clr)
	]]
	
end

local function getRelaton (id)
	local f = unit.GetFaction( id )
	if f then
--[[
  isSame: boolean - true,     ,   ;
  isFriend: boolean - true,      (   );
  isPassive: boolean - true,       ;
  name: WString -   .
  sysName: string -    
]]
		if f.IsFriend then
		end
	else
	end
end

local function getColorDiff (lvl, baseLVL)
	local lvlDiff = lvl - baseLVL + ITEM_QUALITY_UNCOMMON
	if lvlDiff < ITEM_QUALITY_JUNK then lvlDiff = ITEM_QUALITY_JUNK end
	if lvlDiff > ITEM_QUALITY_RELIC then lvlDiff = ITEM_QUALITY_RELIC end
	return lvlDiff
end

local function getNameFormat( v )
	local val = "LogColorWhite"
	if _PS.clr_name ~= OFF and unit.IsPlayer(v) then
		val = CC[unit.GetClass(v).className]
	elseif unit.IsPet( v ) then
		local id = unit.GetPetOwner( v )
		if id and object.IsExist(id) then
			--    
			val = getNameFormat( id )
		else
		end
	elseif unit.IsFriend(v) then
		--common.LogInfo( "common", "getNameFormat" )
		if false then
		elseif v == family.GetSpouseId( Me ) then
			val = "Spouse"
		elseif unit.IsPlayer(v) --[[and group.GetMembers()]] and group.IsPlayerInGroup( v ) or raid.IsExist() and raid.IsPlayerInAvatarsRaidGroup( object.GetName( v ) ) then
			val = "Group"
		elseif raid.IsPlayerInAvatarsRaid( object.GetName( v ) ) then
			val = "Raid"
		else
			val = "Friendly"
		end
	elseif unit.IsEnemy(v) and unit.IsPlayer(v) then
		val = "EpicCursed" --sysItemQualityStyle[ ITEM_QUALITY_RARE ]
		--val = "Epic" --sysItemQualityStyle[ ITEM_QUALITY_RARE ]
		--val = "Aggressive"
	elseif unit.IsEnemy(v) then
		val = sysItemQualityStyle[ ITEM_QUALITY_EPIC ]
	else
		val = "Neutral"
	end
	return val
end

local function getTitleFormat( v )
	if unit.IsFriend(v) then
		return "Friendly"
	elseif unit.IsEnemy(v) and unit.IsPlayer(v) then
		return "Aggressive"
	elseif unit.IsEnemy(v) then
		return sysItemQualityStyle[ ITEM_QUALITY_EPIC ] --ITEM_QUALITY_RELIC
	else
		return "Neutral"
	end
end

local function getHPFormat( v )
	local widthHP
	local plr, frn, ene = unit.IsPlayer(v), unit.IsFriend(v), unit.IsEnemy(v)
	if false then
	elseif plr and frn then widthHP = _PS.a_widthHP --- allies
	elseif plr and not frn then widthHP = _PS.e_widthHP  --- enemies
	elseif not plr and not frn then widthHP = _PS.m_widthHP  --- mobs
	elseif not plr and frn then widthHP = _PS.n_widthHP  --- NPC
	end

	local clr, clrB, sizeY = "Fr", "FrB", tonumber(widthHP) or 10
	---  // -  
	--local f = unit.GetFaction( v )
	if frn then
		--common.LogInfo( "common", "HealthColor" )
		if unit.IsPlayer(v) --[[group.GetMembers()]] and group.IsPlayerInGroup( v ) or raid.IsExist() and raid.IsPlayerInAvatarsRaidGroup( object.GetName( v ) ) then
			clr, clrB = "GP", "GPB"
			sizeY= tonumber(_PS.gpSizeY) or _PS.a_widthHP and _PS.a_widthHP * 2 or 20
		elseif raid.IsPlayerInAvatarsRaid( object.GetName( v ) ) then
			clr, clrB = "RD", "RDB"
			sizeY= tonumber(_PS.rdSizeY) or _PS.a_widthHP and _PS.a_widthHP * 1.5 or 15
		else
		end
	--elseif unit.IsPet( v ) then
	--	clr, clrB = "Ne", "NeB"
	elseif ene and plr then
		clr, clrB = "EP", "EPB"
	elseif ene then
		clr, clrB = "En", "EnB"
	else
		clr, clrB = "Ne", "NeB"
	end
	return clr, clrB, sizeY
end
-------------------------------------------------------------------------------
-- FUNCTION
-------------------------------------------------------------------------------
function NameColor(v)
	if object.IsExist(v) and Name[v] then
		Name[v]:SetClassVal("class", getNameFormat(v))
	end
end

local formatAlignX = {
--<header alignx="center" fontsize="14" outline="1" fontname="-AllodsSystem"><rs class="class"><r name="name"/></rs></header>
--<header alignx="right" fontsize="16" outline="1" outlinecolor="0x99000000" fontname="-AllodsSystem"><rs class="class"><r name="name"/></rs></header>
	[0] = ToWS("<html alignx='left' outline='1' fontsize='17'><rs class='class'><r name='name'/></rs></html>"),
	[1] = ToWS("<html alignx='right' outline='1' fontsize='17'><rs class='class'><r name='name'/></rs></html>"),
	[2] = ToWS("<html alignx='center' outline='1' fontsize='17'><rs class='class'><r name='name'/></rs></html>"),
}
function NameCreate(v)
	local plr, frn, ene = unit.IsPlayer(v), unit.IsFriend(v), unit.IsEnemy(v)
	if ( (plr and frn) and _PS.allies ~= OFF and _PS.a_name ~= OFF ) --- allies
	or ( (plr and not frn) and _PS.enemies ~= OFF and _PS.e_name ~= OFF ) --- enemies
	or ( (not plr and not frn) and _PS.mobs ~= OFF and _PS.m_name ~= OFF ) --- mobs
	or ( (not plr and frn) and _PS.npc ~= OFF and _PS.n_name ~= OFF ) --- NPC
	 then
		local w = Name[v]
	--if _PS.name == ON and object.IsExist(v) and Name[v] and object.IsUnit(v) and object.IsDead(v) == false then
		if unit.IsPet( v ) then
			TitleColor(v)
			Title[v]:SetVal("name", object.GetName(v))
			local id = unit.GetPetOwner( v )
			if id and object.IsExist(id) then
				w:SetVal("name", userMods.ToWString("**"..userMods.FromWString(object.GetName(id)).."**"))
			else
				pets[v] = 1
				--Name[v]:SetVal("name", object.GetName(v))
				--LogToChat("pet is ownless:"..FromWS(object.GetName(v)))
			end
		else
			w:SetVal("name", object.GetName(v))
		end
		if _PS.alignX_name then
			--wtSetPlace( w, { alignX = _PS.alignX_name } )
			w:SetFormat( formatAlignX[ _PS.alignX_name ] )
		end
	end
end
function NameChanged(params)
	local v = params.unitId
	if Name[v] and object.IsExist(v) then
		NameCreate(v)
		NameColor(v)
	end
end

function TitleColor(v)
	Title[v]:SetClassVal("class", getTitleFormat(v))
end
function TitleCreate(v)

	local plr, frn, ene = unit.IsPlayer(v), unit.IsFriend(v), unit.IsEnemy(v)
	if ( (plr and frn) and _PS.allies ~= OFF and _PS.a_title ~= OFF ) --- allies
	or ( (plr and not frn) and _PS.enemies ~= OFF and _PS.e_title ~= OFF ) --- enemies
	or ( (not plr and not frn) and _PS.mobs ~= OFF and _PS.m_title ~= OFF ) --- mobs
	or ( (not plr and frn) and _PS.npc ~= OFF and _PS.n_title ~= OFF ) --- NPC
	 then
		local str, fmrt = userMods.FromWString(unit.GetTitle(v))
		local w = Title[v]
		 --- icreator
		if not unit.IsPlayer(v) then
			--- old vers: unit.GetRelatedQuests - not exist
			local qw, i = unit.GetRelatedQuests and unit.GetRelatedQuests( v )
			if qw then
				i, qw = next(qw)
				qw = qw and avatar.GetQuestInfo(qw)
				if qw then
					fmrt = sysItemQualityStyle[ ITEM_QUALITY_LEGENDARY ]
					str = "? "..userMods.FromWString(qw.name)
				end
			end
		end
		if string.len( str ) > 16 then
			w:SetMultiline( true )
			w:SetWrapText( true )
			w:SetAlignY( 2 )
			w:SetEllipsis( true )
			local p = w:GetPlacementPlain()
			p.sizeY=p.sizeY*3
			if string.len( str ) > 30 then p.sizeY=p.sizeY*1.5 end
			w:SetPlacementPlain(p)
		end
		if fmrt then w:SetClassVal("class", fmrt ) end
		w:SetVal("name", userMods.ToWString(str) )

	end
end

function HealthColor(v)
	if object.IsExist(v) and widgets[v] then
		local healthbar = widgets[v]:GetChildChecked("HealthBar", false)
		local clr, clrB, sizeY = getHPFormat( v )
		local p = healthbar:GetPlacementPlain()

		if unit.IsPet( v ) then
			--exObj("faction", unit.GetFaction(v) )
--[[
Info: addon NamePlateBars2: faction.isSame=true{boolean}
Info: addon NamePlateBars2: faction.name="{WString}
Info: addon NamePlateBars2: faction.sysName="Empire"
Info: addon NamePlateBars2: faction.isFriend=true{boolean}
Info: addon NamePlateBars2: faction.isPassive=false{boolean}
]]
			sizeY = sizeY*0.7
			local sizeYP
			local id = unit.GetPetOwner( v )
			if id and object.IsExist(id) then 
				clr, clrB, sizeYP = getHPFormat( id ) ---        
				sizeY = sizeYP and sizeYP*0.7 or sizeY
			else
				clr, clrB = "Ne", "NeB"
				--healthbar:Show( false )
				--exObj("faction ownless", unit.GetFaction(v) )
			end
		else
			--clr, clrB, sizeY = 
		end
		p.sizeY = sizeY
		healthbar:SetPlacementPlain(p)
		healthbar:GetChildChecked("Bar", false):SetBackgroundColor(Color[clr])
		healthbar:SetBackgroundColor(Color[clrB])
	end
end

local function TargNameCreate( w, v )
	local plr, frn, ene = unit.IsPlayer(v), unit.IsFriend(v), unit.IsEnemy(v)
	if ( (plr and frn) and _PS.a_targName ~= OFF ) --- allies
	or ( (plr and not frn) and _PS.e_targName ~= OFF ) --- enemies
	or ( (not plr and not frn) and _PS.m_targName ~= OFF ) --- mobs
	or ( (not plr and frn) and _PS.n_targName ~= OFF ) --- NPC
	 then
		local wt = w:GetChildChecked("TargName", false)
		TargName[v] = wt
		--TargName[v] = WCD( dsc.Text, nil, nil, { alignX = 0, sizeX = 150, alignY = 0, sizeY = 30 }, true )
		wtSetPlace( wt, { highPosY = 3, sizeY = 16 } )
		--TargName[v]:SetFormat(ToWS('<header alignx="left" fontname="AllodsSystem" fontsize="18" shadow="1" shadowcolor="0xFFFFFFFF"><rs class="class"><r name="name"/></rs></header>'))
		wt:SetFormat(ToWS('<header alignx="left" fontname="AllodsSystem" fontsize="18" outline="1" outlinecolor="0xFF333333"><rs class="class"><r name="name"/></rs></header>'))
		wt:SetPriority( 100 )
		wt:SetAlignY( 1 )
	end
end


function DetectChanged(p)
	local v = p.objectId
	if widgets[v] and Name[v] and object.IsExist(v) and object.IsUnit(v) and object.IsDead(v) == false then
		ProjectedCreate(v)
	end
end

function LevelCreate(v)
	---if _PS.level == ON and Level[v] and object.IsExist(v) then
	local plr, frn, ene = unit.IsPlayer(v), unit.IsFriend(v), unit.IsEnemy(v)
	if ( (plr and frn) and _PS.allies ~= OFF and _PS.a_level ~= OFF ) --- allies
	or ( (plr and not frn) and _PS.enemies ~= OFF and _PS.e_level ~= OFF ) --- enemies
	or ( (not plr and not frn) and _PS.mobs ~= OFF and _PS.m_level ~= OFF ) --- mobs
	or ( (not plr and frn) and _PS.npc ~= OFF and _PS.n_level ~= OFF ) --- NPC
	 then
		--- icreator
		local lvl = unit.GetLevel(v)
		Level[v]:SetClassVal("class", sysItemQualityStyle[ getColorDiff( lvl, MyLVL )  ] )
		Level[v]:SetVal("name", userMods.ToWString( lvl.."" ))
	end
end
function LevelChanged(p)
	local v = p.unitId
	if v == Me then --- icreator
		MyLVL = unit.GetLevel( Me )
	elseif Level[v] and object.IsExist(v) and object.IsUnit(v) and object.IsDead(v) == false then
		LevelCreate(v)
	end
end

local function ClassCreate(v, wt)
	local w = W("panClass", wt)
	w:Show(false)
	local plr, frn, ene = unit.IsPlayer(v), unit.IsFriend(v), unit.IsEnemy(v)
	if plr then
		if ( frn and _PS.allies ~= OFF and _PS.a_class ~= OFF ) --- allies
		or ( not frn and _PS.enemies ~= OFF and _PS.e_class ~= OFF ) --- enemies
		--or ( (not plr and not frn) and _PS.mobs ~= OFF and _PS.m_level ~= OFF ) --- mobs
		--or ( (not plr and frn) and _PS.npc ~= OFF and _PS.n_level ~= OFF ) --- NPC
		 then
			if _PS.plcClassAsQuality ~= ON then
				local unitClass = unit.GetClass(v)
				unitClass = ClassNames[unitClass.className]
				if unitClass then
					w:SetBackgroundTexture( common.GetAddonRelatedTexture( unitClass ) )
					w:Show(true)
				end
			else
				w:Show( false )
			end
		end
	else
		if ( not frn and _PS.mobs ~= OFF and _PS.m_quality ~= OFF ) --- mobs
		or ( frn and _PS.npc ~= OFF and _PS.n_quality ~= OFF ) --- NPC
		 then
			local quality = unit.GetQuality(v)
			if quality == 0 or ( quality and _PS.plcQualityAsClass == OFF ) then
				w:Show(false)
			else
				local layer
				if quality == 1 or quality == 6 then
					layer = "Silver"
				elseif quality == 4 or quality == 5 then
					layer = "Red"
				elseif quality == 2 then
					layer = "Golden"
				elseif quality == 3 then
					layer = "Copper"
				end
				--LogToChat(layer)
				if layer then
					w:SetBackgroundTexture(common.GetAddonRelatedTexture(layer))
					w:Show(true)
				else
				end
			end
		end
	end

end

local function GuildColor( v, gName)
	local clr = sysItemQualityStyle[ ITEM_QUALITY_GOODS ]
	local gN = gName or userMods.FromWString( unit.GetGuildName(v) )
	if MyGuild ~= "" and MyGuild == gN then
		---   
		clr = sysItemQualityStyle[ ITEM_QUALITY_LEGENDARY ] --ITEM_QUALITY_RELIC
	elseif not unit.IsEnemy(v) then
		if not unit.IsFriend(v) then
			---    - 
			clr = "Neutral"
		else
			---    
			---clr =  sysItemQualityStyle[ ITEM_QUALITY_JUNK ])
		end
	else
		clr = "EpicCursed"
		--clr = "Epic" --sysItemQualityStyle[ ITEM_QUALITY_RARE ]
		--clr = "Aggressive" ---sysItemQualityStyle[ ITEM_QUALITY_JUNK ])
	end
	Title[v]:SetClassVal("class", clr )
	--Title[v]:SetFormat(ToWS('<header alignx="center" fontsize="18" outline="1" fontname="AllodsSystem"><rs class="class"><r name="name"/></rs></header>'))
	Title[v]:SetFormat(ToWS('<header alignx="center" fontsize="16" outline="1" ><rs class="class"><r name="name"/></rs></header>'))
end

local function GuildCreate(v)
	local gN = unit.GetGuildName(v)
	local gName = userMods.FromWString( gN )
	if Me == v then MyGuild = gName end
	local frn, ene = unit.IsPlayer(v), unit.IsFriend(v), unit.IsEnemy(v)
	if ( frn and _PS.allies ~= OFF and _PS.a_title ~= OFF ) --- allies
	or ( not frn and _PS.enemies ~= OFF and _PS.e_title ~= OFF ) --- enemies
	 then
	--if _PS.title == ON and "" ~= gName then
		---local w = Title[v]
		GuildColor( v, gName )
		Title[v]:SetVal("name", gN)
		---Title[v]:SetTextScale(.9)
	end
end

local function findPetOwner ( id )
	local ownerId
	for petId in pets do
		ownerId = unit.GetPetOwner( petId )
		if ownerId and ownerId == id then
			--LogToChat("owner found")
			RelationChanged( { unitId = petId } )
			pets[petId] = nil
			break
		end
	end
end

function UnitSpawned(params)
	local v = params.unitId
	if not widgets[v] then
		Create(v)
		findPetOwner( v )
	else
	end
	if widgets[v] then
		widgets[v]:Show(true)
	end
end

function UnitDespawned(params)
	local v = params.unitId
	local w, t = widgets[v], TargName[v]
	if w --and not (object.IsExist(v) --[[and unit.IsPlayer(v) and (group.IsPlayerInGroup(v) or raid.IsPlayerInAvatarsRaid(object.GetName(v))) ]] )
		then
		widgets[v] = nil
		Name[v], TargName[v], TargID[v] = nil, nil, nil
		Level[v] = nil
		Title[v] = nil
		units[v] = nil
		DetIcons[v] = nil
		pets[v] = nil
		wtControl3D:RemoveWidget3D(w)
		w:DestroyWidget()

		--wtControl3D:RemoveWidget3D(t)
		--t:DestroyWidget()
	end
end

function Detect(params)
	local v = params.objectId
	if v and object.IsExist(v) and object.IsUnit(v) and object.IsDead(v) == false and DetIcons[v] then
		ProjectedCreate(v)
	end
end

function RelationChanged(params)
--[[
	local v = params.unitId
	if Name[v] and object.IsExist(v) and object.IsUnit(v) and object.IsDead(v) == false then
		NameCreate(v)
		NameColor(v)
		HealthColor(v)
		if unit.IsPlayer(v) then GuildCreate(v) end
		ProjectedCreate(v)
	end
]]
	UnitDespawned( params )
	UnitSpawned( params )

	local targId =  params.unitId
	for id, w in TargName do
		if TargID[ id ] == targId then
			w:SetClassVal("class", getNameFormat( targId ) )
		end
	end

end


function ProjectedCreate(v)
	if object.IsExist(v) then
		if unit.IsPlayer(v) and Name[v] then
			if false and unit.IsFriend(v) then
				--common.LogInfo( "common", "ProjectedCreate" )
				if group.GetMembers() and group.IsPlayerInGroup(v) then
					DetIcons[v]:SetBackgroundTexture(common.GetAddonRelatedTexture("Group"))
					DetIcons[v]:Show(true)
				end
				if raid.IsExist() then
					if raid.IsPlayerInAvatarsRaidGroup(object.GetName(v)) then
						DetIcons[v]:SetBackgroundTexture(common.GetAddonRelatedTexture("Group"))
						DetIcons[v]:Show(true)
					elseif raid.IsPlayerInAvatarsRaid(object.GetName(v)) then
						DetIcons[v]:SetBackgroundTexture(common.GetAddonRelatedTexture("Raid"))
						DetIcons[v]:Show(true)
					end
				end
			end
			if _PS.plcClassAsQuality == ON then
				local unitClass = unit.GetClass(v)
				unitClass = ClassNames[unitClass.className]
				if unitClass then
					DetIcons[v]:SetBackgroundTexture( common.GetAddonRelatedTexture( unitClass ) )
					DetIcons[v]:Show(true)
				end
			else
				DetIcons[v]:Show( false )
			end

		else
			local layer
			for j, x in avatar.GetDetectedObjects() do
				if x == v then
					local detectors = object.GetDetectors( v )
					local Intera = object.GetInteractorInfo(v)
					if Intera.isVendor then layer = "Vendor"..Intera.vendorType end
					if Intera.isReputationVendor then layer = "Reputation" end
					if Intera.isHonorVendor then layer = "Hon"..unit.GetFaction(avatar.GetId()).sysName end
					if Intera.isQuestGiver then 
						if object.HasOnlyRepeatableQuests(v) and (object.GetQuestMark(v) == 1 or object.GetQuestMark(v) == 3) then
							layer = "QR"..object.GetQuestMark(v)
						else
							layer = "Q"..object.GetQuestMark(v)
						end
					end
					if Intera.isSecretFinisher then layer = "SecretDone" end
					if Intera.isSecretRelated then layer = "Secret" end
					if Intera.isTrainer then layer = "Trainer" end
					if Intera.isAuction then layer = "Auction" end
					if Intera.isDepositeBoxAccessor then layer = "Safe" end
					if Intera.canTakeRestedExp then layer = "Inn" end
					if Intera.isRemortMaster then layer = "Remort" end
					if Intera.isMailBox then layer = "Mail" end
					if Intera.isTeleportMaster then layer = "Teleporter" end
					if Intera.extended and Intera.extended[1] then layer = "June" end
					if layer and DetIcons[v] then
						DetIcons[v]:SetBackgroundTexture(common.GetAddonRelatedTexture(layer))
						DetIcons[v]:Show(true)
					end
				end
			end
			if layer == nil and not unit.IsFriend(v) then
				local quality = unit.GetQuality(v)
				if quality == 0 or ( quality and (_PS.m_quality == OFF or _PS.plcQualityAsClass == ON )) then
					DetIcons[v]:Show(false)
				else
					if quality == 1 or quality == 6 then
						layer = "Silver"
					elseif quality == 4 or quality == 5 then
						layer = "Red"
					elseif quality == 2 then
						layer = "Golden"
					elseif quality == 3 then
						layer = "Copper"
					end
					local P = DetIcons[v]:GetPlacementPlain()
					P.sizeX = 48
					P.sizeY = 48
					DetIcons[v]:SetPlacementPlain(P)
					if layer then
						DetIcons[v]:SetBackgroundTexture(common.GetAddonRelatedTexture(layer))
						DetIcons[v]:Show(true)
					else
						DetIcons[v]:Show(false)
					end
				end
			elseif layer == nil then
				DetIcons[v]:Show(false)
			end
		end
	end
end

function Create(v)
	if v and object.IsUnit(v) and object.IsDead(v) == false then
		local plr, frn, ene = unit.IsPlayer(v), unit.IsFriend(v), unit.IsEnemy(v)
		if ( (plr and frn) and _PS.allies ~= OFF ) --- allies
		or ( (plr and not frn) and _PS.enemies ~= OFF ) --- enemies
		or ( (not plr and not frn) and _PS.mobs ~= OFF ) --- mobs
		or ( (not plr and frn) and _PS.npc ~= OFF ) --- NPC
		 then
			local w = mainForm:CreateWidgetByDesc(widgetdesc)
			local sizeX, sizeY
			if plr and frn then sizeX, sizeY = _PS.a_sizeX, _PS.a_sizeY --- allies
			elseif plr and not frn then sizeX, sizeY = _PS.e_sizeX, _PS.e_sizeY --- enemies
			elseif not plr and not frn then sizeX, sizeY = _PS.m_sizeX, _PS.m_sizeY --- mobs
			elseif not plr and frn then sizeX, sizeY = _PS.n_sizeX, _PS.n_sizeY --- NPC
			end
			sizeX = tonumber(sizeX)
			sizeY = tonumber(sizeY)
			if sizeX or sizeY then
				wtSize(w, sizeX, sizeY)
			end

			widgets[v] = w
			units[v] = v
			ClassCreate(v, w)
			Name[v] = w:GetChildChecked("Name", false)
			TargNameCreate( w, v )

			--w:Show( false )
			Title[v] = w:GetChildChecked("Title", false)
			Level[v] = w:GetChildChecked("Level", false)
			---Name[v]:SetBackgroundColor(Color.BG)
			local healthbar = w:GetChildChecked("HealthBar", false)
			if ( (plr and frn) and _PS.a_health ~= OFF ) --- allies
			or ( (plr and not frn) and _PS.e_health ~= OFF ) --- enemies
			or ( (not plr and not frn) and _PS.m_health ~= OFF ) --- mobs
			or ( (not plr and frn) and _PS.n_health ~= OFF ) --- NPC
			 then
				healthbar:Show( true )
			else
				healthbar:Show( false )
			end

			--[[if unit.IsEnemy(v) and unit.IsPlayer(v) then
				healthbar:Show(_PS.ephealth == ON)
			elseif unit.IsEnemy(v) then
				healthbar:Show(_PS.ehealth == ON)
			elseif unit.IsFriend(v) and unit.IsPlayer(v) then
				healthbar:Show(_PS.phealth == ON)
			else
				healthbar:Show(_PS.health == ON)
			end
			]]
			--healthbar:SetBackgroundColor(Color.BG)
			--if not _PS.name == ON and not _PS.level == ON then --- icreator
			---Name[v]:SetBackgroundColor(Color.In)
			--end

			if false and FromWS(object.GetName(v)) == "" then
				---       -     !      
				exObj("IsPlayer", unit.IsPlayer( v ) )
				exObj("IsPet", unit.IsPet( v ) )
				exObj("Faction", unit.GetFaction( v ) )
			end
			
			NameCreate(v,w)
			NameColor(v,w)
			HealthColor(v,w)
			DetIcons[v] = w:GetChildChecked("Icon", false)
			DetIcons[v]:Show(false)
			ProjectedCreate(v, w)
			if unit.IsPlayer(v) then
				GuildCreate(v, w)
			else --- icreator
				TitleColor(v, w)
				TitleCreate(v, w) --       
			end
			LevelCreate(v, w)

			--wtControl3D:AddWidget3D(TargName[v],{ sizeX = 1, sizeY = 0 },object.GetPos( avatar.GetId() ),false,true,400,WIDGET_3D_BIND_POINT_HIGH, 0.7, 1 )
			--object.AttachWidget3D( v, wtControl3D, TargName[v], -0.2)

			wtControl3D:AddWidget3D(widgets[v],{ sizeX = 1, sizeY = 0 },object.GetPos( avatar.GetId() ),false,true,400,WIDGET_3D_BIND_POINT_HIGH, 0.7, 1 ) --0.7,2.5 )
			object.AttachWidget3D( v, wtControl3D, widgets[v], 0.0)

			userMods.SendEvent( 'UNIT_PLATE_ATTACHED', { id = v, w = widgets[v], pos = WIDGET_3D_BIND_POINT_HIGH, mode = "3D" } )
			HPbarSize(healthbar, v)
		end
	end
end

local oldGMS = {}
local function colorGroup( GMS )
	local id, old_id
	for i=0,5 do
		id = GMS[i]
		id = id and id.id
		old_id = oldGMS[i]
		old_id = old_id and old_id.id
		if id and id ~= old_id then
			NameColor( id )
			HealthColor( id )
		end
	end
end

local function onGroupChanged()
	local GMS = group.GetMembers() or {}
	colorGroup( GMS )
	oldGMS = GMS
end
local oldRMS = {}
local function onRaidChanged()
	local RMS = raid.GetMembers() or {}
	local GMS, id, old_id
	for i=0,3 do
		GMS = RMS[i] or {}
		colorGroup( GMS )
	end
	oldRMS = RMS
	onGroupChanged()
end

function GuildChanged(p)
	local v = p.unitId
	if widgets[v] ~= nil and object.IsExist(v) then
		GuildCreate(v)
	end
	if v == Me then
		---        
		for v, w in Title do
			GuildColor( v )
		end
	end
end

function UnitHPercChanged(params)
	local v = params.unitId
	if Name[v] then
		local plr, frn, ene = unit.IsPlayer(v), unit.IsFriend(v), unit.IsEnemy(v)
		if ( (plr and frn) and _PS.allies ~= OFF and _PS.a_health ~= OFF ) --- allies
		or ( (plr and not frn) and _PS.enemies ~= OFF and _PS.e_health ~= OFF ) --- enemies
		or ( (not plr and not frn) and _PS.mobs ~= OFF and _PS.m_health ~= OFF ) --- mobs
		or ( (not plr and frn) and _PS.npc ~= OFF and _PS.n_health ~= OFF ) --- NPC
			------and not unit.IsPlayer(v) and (unit.IsFriend(v) or not unit.IsEnemy(v)))
		then
			--- icreator
			if false then --- not unit.IsPlayer(v) and unit.IsTagged(v) and not unit.IsTaggedByMainPlayer(v) then
				Name[v]:SetClassVal("class", "Dead")
			elseif object.IsDead(v) then
				Name[v]:SetClassVal("class", "Dead")
				widgets[v]:GetChildChecked("HealthBar", false):Show( false )
			else
				NameColor(v)
				widgets[v]:GetChildChecked("HealthBar", false):Show( true )
				HPbarSize(widgets[v]:GetChildChecked("HealthBar", false), v)
			end
			--- icreator
		end
	end
end

function TagChanged(p)
	RelationChanged(p)
end
		
local effs = {}

local function showEmote( wt, pars )
	local w, txt, done = wt:GetChildChecked("Emote1", false), wt:GetChildChecked("Emote_txt", false)

	if false then
	elseif pars.image2 then w:SetBackgroundTexture( pars.image2 ) done = 1
	elseif pars.image then w:SetBackgroundTexture( pars.image ) done = 1
	end
	if pars.text then
		txt:SetVal("name", pars.text ) 
		txt:SetFade(1)
		txt:Show(true) 
		effs[txt:GetInstanceId()] = function( ww ) ww:PlayFadeEffect( 1, 0.7, 1500, EA_MONOTONOUS_INCREASE ) end
		txt:FinishFadeEffect()
		txt:PlayFadeEffect( 1, 1, 2500, EA_MONOTONOUS_INCREASE )
	end

	if done then
		--- -  -   
		effs[w:GetInstanceId()] = function( ww ) ww:PlayFadeEffect( 1, 0.5, 2000, EA_MONOTONOUS_INCREASE ) end
		local fromP = Clone(emotePlace)
		fromP.sizeX = emotePlace.sizeX * 2
		fromP.sizeY = emotePlace.sizeY * 2
		w:SetFade(1)
		w:Show(true)
		w:FinishResizeEffect()
		w:PlayResizeEffect( fromP, emotePlace, 500, EA_MONOTONOUS_INCREASE )
	end
end
local function onEmoteText( pars )
--[[
id: ObjectId (not nil) -    
targetId: ObjectId -    nil
text: WString -     ( ),    /     (..    )
isAlive: boolean -   ( )   (   )
image: TextureId -    ()
image2: TextureId -     ()
]]
	--exObj("pars", pars)

	local id = pars.id
	--if id == Me then id = unit.GetTarget( Me ) end

	local w = widgets[id]
	if not w or not object.IsExist( id ) then return end
	showEmote( w, pars )

end
local function onEVENT_UNIT_MOOD_CHANGED( pars )
	--exObj("pars", pars )
	local id = pars.unitId
	--if id == Me then id = unit.GetTarget( Me ) end

	local emoteId = unit.GetMoodEmoteId( id )
	local emoteInfo = emoteId and avatar.GetEmoteInfo( emoteId )
	if emoteInfo then
		local w = widgets[id]
		if w then
			emoteInfo.text = emoteInfo.name
			showEmote( w, emoteInfo )
		end
	end
end

local function onEVENT_EFFECT_FINISHED( pars )
	local ID = pars.wtOwner:GetInstanceId()
	local func = effs[ID]
	if not func then return end
	effs[ID] = function(ww) ww:Show( false ) effs[ww:GetInstanceId()] = nil end
	func( pars.wtOwner )
	
end
local function onEvent_EVENT_DEVICE_SPAWNED( pars )
	local id, str, wt, w = pars.id
	local pos = object.GetPos( avatar.GetId() )
	if not pos then return end

	wt = mainForm:CreateWidgetByDesc(wtDevDesc)
	widgets[id] = wt
	w = wt:GetChildChecked("Name", false)
	str = FromWS( object.GetName( id ) )
	if string.len( str ) > 16 then
		w:SetMultiline( true )
		w:SetWrapText( true )
		w:SetAlignY( 2 )
		w:SetEllipsis( true )
		local p = w:GetPlacementPlain()
		p.sizeY=p.sizeY*3
		w:SetPlacementPlain(p)
	end
	--if fmrt then w:SetClassVal("class", fmrt ) end
	w:SetVal("name", ToWS(str) )
	w:Show( true )

	w = wt:GetChildChecked("Title", false)
	w:SetVal("name", device.GetTitle(id) )
	w:Show( true )

	wtControl3D:AddWidget3D( wt,{ sizeX = 1, sizeY = 0 }, pos,false,true,400,WIDGET_3D_BIND_POINT_HIGH, 0.7,2.5 )
	object.AttachWidget3D( id, wtControl3D, wt, 0)
end

local function onEvent_EVENT_DEVICE_DESPAWNED( pars )
	local id = pars.id
	local w = widgets[id]
	if w then
		wtControl3D:RemoveWidget3D(w)
		w:DestroyWidget()
		widgets[id] = nil
	end
end

onEvent["EVENT_FAMILY_CREATED"] = function ( pars )
	NameColor( pars.unitId )
end
onEvent["EVENT_FAMILY_DESTROYED"] = function ( pars )
	NameColor( pars.unitId )
end
onEvent["EVENT_SECOND_TIMER"] = function ( pars )
	local targId
	for unitId, w in TargName do
		targId = object.IsExist( unitId ) and unit.GetTarget( unitId )
		if targId ~= TargID[unitId] then
			TargID[unitId] = targId
			if targId then
				w:SetVal("name", object.GetName( targId ) )
				--w:SetVal("value", object.GetName( targId ) )
				w:SetClassVal("class", getNameFormat( targId ) )
				w:Show( true )
			else
				w:Show( false )
			end
		end
	end
end

--------------------------------------------------------------------------------
-- INITIALIZATION
--------------------------------------------------------------------------------
function InitNPB2()
	Me = avatar.GetId() --- icreator
	MyLVL = unit.GetLevel( Me )
	MyGuild = userMods.FromWString( unit.GetGuildName(Me) or "" )

	for i, v in avatar.GetUnitList() do
		Create(v)
	end
	for _, id in avatar.GetDeviceList() do
		onEvent_EVENT_DEVICE_SPAWNED( { id = id } )
	end

	--common.RegisterEventHandler(UnitsChanged, "EVENT_UNITS_CHANGED")
	common.RegisterEventHandler(UnitSpawned, "EVENT_UNIT_SPAWNED")
	common.RegisterEventHandler(UnitDespawned, "EVENT_UNIT_DESPAWNED")
	common.RegisterEventHandler(Detect, "EVENT_OBJECT_DETECT_STARTED")
	common.RegisterEventHandler(Detect, "EVENT_OBJECT_DETECT_FINISHED")
	common.RegisterEventHandler(RelationChanged, "EVENT_UNIT_RELATION_CHANGED")
	common.RegisterEventHandler(NameChanged, "EVENT_UNIT_NAME_CHANGED")
	common.RegisterEventHandler(UnitHPercChanged, "EVENT_UNIT_HEALTH_PERCENTAGE_CHANGED")
	common.RegisterEventHandler(DetectChanged, "EVENT_OBJECT_DETECTOR_LIST_CHANGED")
	common.RegisterEventHandler(LevelChanged, "EVENT_UNIT_LEVEL_CHANGED")
	common.RegisterEventHandler(TagChanged, "EVENT_UNIT_TAG_CHANGED")
	common.RegisterEventHandler(GuildChanged, "EVENT_GUILD_CHANGED")
 	common.RegisterEventHandler( onGroupChanged, "EVENT_GROUP_CHANGED" )
 	common.RegisterEventHandler( onRaidChanged, "EVENT_RAID_CHANGED" )
	--common.RegisterEventHandler(Slash, "EVENT_UNKNOWN_SLASH_COMMAND")
 	common.RegisterEventHandler( onEmoteText, "EVENT_EMOTE_TEXT" )
 	--common.RegisterEventHandler( onEVENT_UNIT_MOOD_CHANGED, "EVENT_UNIT_MOOD_CHANGED" )

 	common.RegisterEventHandler( onEVENT_EFFECT_FINISHED, "EVENT_EFFECT_FINISHED" )
 	common.RegisterEventHandler( onEvent_EVENT_DEVICE_SPAWNED, "EVENT_DEVICE_SPAWNED" )
 	common.RegisterEventHandler( onEvent_EVENT_DEVICE_DESPAWNED, "EVENT_DEVICE_DESPAWNED" )

	RegisterEventHandlers( onEvent )


end
